# -*- coding: utf-8 -*-
"""
Created on Fri Dec 08 20:52:27 2017

@author: Joep
"""
from __future__ import division
import matplotlib.pyplot as plt
import matplotlib as mpl
from scipy.optimize import fsolve
from scipy.optimize import fmin
import numpy as np
#from matplotlib2tikz import save as tikz_save
import math
import random
import os.path
from cycler import cycler
#import cloud.serialization.cloudpickle as clo
#import pickle
import time
import math
import itertools

plot=plt.plot
mpl.rcParams['axes.prop_cycle'] = cycler('color', ['gray', 'darkgreen', 'red','blue','orange'])+cycler('linestyle', [':', '-',  '--','-.','-'])


n_end=11
n_st=n_end+4 #constant and shock

lossmeasure='equal' #set to 'equal' for euqally weitghed loss or to 'welfare' for welfare loss



#y, pi, i, b, tau, br,cr, gshock, yshock, pishock




def eval_plm(vec_lag,x,var,n_end,n_st):
    som=0
    for ij in range(n_st):    
        som+=vec_lag[ij]*x[ij*n_end+var]
    return som

def eval_msv(msv,var,vec_lag):
    som=msv[0][var]
    for y in range(1,n_st-1):
        som+=msv[y][var]*vec_lag[y]
    return som



#y, pi, i, b, tau, br, cr,  ischock, tauschok
def calc_RHS(vec_lag,vec_next):
    RHStot=[0]*n_end 
    RHStot[0]=phi8*vec_next[0]+phi13*vec_lag[0]+phi9*vec_next[1]+phi14*vec_lag[1]+phi18*vec_lag[2]+phi10*vec_next[2]\
             -phi20*vec_lag[5]+phi19*vec_lag[3]-phi11*vec_next[9]-phi14*vec_lag[9]-phi12*vec_next[8]-phi15*vec_lag[8]          
    RHStot[1]= beta*vec_next[1] 
    RHStot[2]=0       
    RHStot[3]=(1/beta-Gammatau*phi_b)*vec_lag[3]+bbar/beta*vec_lag[2]
    RHStot[4]=phi_b*vec_lag[3]
    RHStot[5]=1/beta*vec_lag[5]+bbar/beta*vec_lag[2] 
    RHStot[6]=-(1-alpha)/(alpha*(1-gbar))*(vec_lag[0]+(xi-gbar)*vec_lag[8])-(1-alpha)/(alpha*sigma)*(vec_lag[1]-vec_lag[9])\
                +psi*vec_lag[5]-psi*vec_lag[3]    
    RHStot[7]=0
    RHStot[8]=rho_g*vec_lag[8]+vec_lag[11]
    RHStot[9]=rho_PR*vec_lag[9]+vec_lag[12]
    RHStot[10]=rho_CP*vec_lag[10]+vec_lag[13]

    return RHStot




def statefunc(x,*Ainv): 
    # state variables are: a constant (later think about zlb and DS), Y-1,p-1,s-1,B-1,ni-1,g-1,tau-1, innovation of prefshock    
#    print(Ainv[0])
    Ainv=Ainv[0]
    RHS=[0]*len(x)
    stackvec=[0]*len(x)
    
    for jj in range(n_st):
        vec_lag=np.zeros(n_st)
        vec_lag[jj]=1
        vec=np.zeros(n_st) 
#        vec_endo=np.zeros(n_st)
        vec_next=np.zeros(n_end)   
        
        #calcualte current period

        if jj==n_st-1:
            vec[n_st-1]=1 # we are interested in constants, also after one iteration. 
    
        for hh in range(0,n_end): # normal state verianbels. not for constant and ex shock
            var=hh
            vec[hh]=eval_plm(vec_lag,x,var,n_end,n_st)
   
        #calcualte next period
        for hi in range(0, n_end):
            var=hi
            vec_next[hi]=eval_plm(vec,x,var,n_end,n_st)
            

        RHS[n_end*jj:n_end*jj+n_end]=calc_RHS(vec_lag,vec_next)


        stackvec[n_end*jj:n_end+n_end*jj]=np.dot(np.array(Ainv),np.array(RHS[n_end*jj:n_end+n_end*jj]))
    equations=[]
    for i in range(len(x)):
        equations.append(stackvec[i]-x[i])
    return equations
#
#




PRsk=0
CPsk=1


N=17 #simualte N periods  





theo_welfare_equal=[]
theo_welfare=[]
theo_ineqvar=[]
theo_Yvar=[]
theo_Pvar=[]
theo_bvar=[]
parameters=[]
ier_list=[]
N=20
N2=1

counter=-1
init=[0]*n_st*n_end

alpha =  0.877


beta = 0.99;
theta = 1;

sigma = 3.845;
eta = 7.84; 
gamma = 4.481
omega = 0.75;
delta = (1-omega*beta)*(1-omega)/omega;

#    phi_pi = 2.7583
phi_b = 1
phi_bg = 0
phi_cp_g = 0
phi_cp_ni =0
phi_pr_g =0
phi_pr_ni =-0
phi_pr_g_lag=-0



psi=0.0625
chi=1



rho_g=0.8503
rho_PR=0.9278
rho_CP=0.8412
        

gbar = 0.2;
taubar = 0.375;
Tbar=taubar
a1 = (gamma+sigma/(1-gbar));
a2 = eta/delta;
a3 = ((1-gbar)*sigma+(sigma**2/gamma**2));


# i_bar = 1/beta-1;


ybar=(1/(1-gbar)**sigma)**(1/(gamma+sigma))
bbar = (gbar-Tbar/ybar+(1/eta))/(1-1/beta)

lbar=ybar
cbar=ybar*(1-gbar)

s=1/eta



xi=sigma*gbar*(1-gbar)**(-1)/(gamma+(sigma/(1-gbar)));


Gammag = ((gamma+eta)*sigma*gbar)/((1-gbar)*eta*gamma);

zeta = ((1-beta)*gamma)/(beta*(gamma*(1-gbar)+sigma));
Gammay =  1+(1+gamma)/eta + ((eta+gamma)*sigma)/(eta*gamma*(1-gbar))

Gammatau =Tbar/ybar
Gammac = (1-gbar)+(sigma/gamma);

phi_yt=s*(gamma+sigma/(1-gbar)+1)/Gammatau;
phi_gt=phi_yt*xi-s/Gammatau*sigma*gbar/(1-gbar);
phi1 = (1-gbar)*(bbar*alpha*zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi2  = (1-gbar)*(1-alpha*(1-beta))/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi3 = (1-gbar)*alpha*beta*zeta*Gammatau/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi4 = (1-gbar)*psi*alpha*beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi5 = (1-gbar)*alpha*beta*(psi-zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi6 = (gbar-(1-gbar)*beta*alpha*Gammag*zeta-xi*(1-(1-gbar)*alpha*beta*Gammay*zeta))/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi7= (1-gbar)*((1-alpha)+alpha*beta)/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi8 = beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi9 = (1-gbar)*alpha*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi10 = (1-gbar)*(1-alpha)*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi11 = (1-gbar)*beta/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi12 = beta*(gbar-xi)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi13 = (1-alpha)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi14 = (1-gbar)*(1-alpha)/((1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta)*sigma);
phi15 = (1-alpha)*(gbar-xi)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi16 = (1-alpha)*beta/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi17 = (1-alpha)*beta*(gbar-xi)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi18 = (1-gbar)*alpha*zeta*bbar/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi19 = (1-gbar)*alpha*psi/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);
phi20 = (1-gbar)*alpha*(psi-zeta)/(1-(1-gbar)*beta*alpha*Gammay*zeta+(1-alpha)*beta);






def loss(phi_pi):   
#    print(phi_y)     
    init=[0]*n_st*n_end
  
    phi_pi=phi_pi[0]

    
    
    A=np.array([[1,phi1+phi10,phi2,phi4,phi3,-phi5,0,0,-(phi6+phi17),-(phi7+phi10),0],
                [-delta*(gamma+sigma/(1-gbar)),1,0,0,0,0,0,0,0,0,-1],
                [-phi_y,-phi_pi,1,0,0,0,0,0,0,0,0],
                [0,bbar/beta,0,1,0,0,0,0,-gbar,0,0],
                [-phi_yt, 0, 0, 0,1,0,0,0,-phi_gt,0,0],
                [-Gammay,bbar/beta,0,0,Gammatau,1,Gammac,0,-(Gammay*xi-Gammag),0,0],
                [-1/(alpha*(1-gbar)),0,-(1-alpha)/(alpha*sigma),0,0,0,1,0,-(xi-gbar)/(alpha*(1-gbar)),(1-alpha)/(alpha*sigma),0],
                [-1/((1-alpha)*(1-gbar)),0,0,0,0,0,alpha/(1-alpha),1,gbar/((1-alpha)*(1-gbar)),0,0],
                [0,0,0,0,0,0,0,0,1,0,0],
                [0,0,0,0,0,0,0,0,0,1,0],
                [0,0,0,0,0,0,0,0,0,0,1]
                ])
    
    Ainv=np.linalg.inv(A)





    
#    T=statefunc(init)


    [msv_coefs,inf,ier,mes] = fsolve(statefunc, init,full_output=1,maxfev=1000, args=Ainv)  
 
    if ier != 1:
        print( mes)

    Omega=np.transpose(msv_coefs[:n_end*n_end].reshape(n_end,n_end))
    Lambda=np.transpose(msv_coefs[n_end*n_end:-n_end].reshape(3,n_end))
    
    
    Sig=np.zeros((3,3))
    Sig[0,0]=2.25**2
    Sig[1,1]=1.87**2
    Sig[2,2]=1.64**2

    
    Sigv=Sig.reshape(-1,1)


    id2=np.identity((n_end)**2)

    varv=np.dot(np.linalg.inv(id2-np.kron(Omega,Omega)),np.dot(np.kron(Lambda,Lambda),Sigv))

    variances=varv.reshape(n_end,n_end)       
   

    theo_ineqvart=alpha*(1-alpha)*(variances[6,6]+variances[7,7]-2*variances[6,7])
    theo_Yvart=variances[0,0]
    theo_Pvart=variances[1,1]

    theo_welfare=ybar*cbar**(-sigma)/(2*(1-beta))*(a1*theo_Yvart+a2*theo_Pvart+a3*theo_ineqvart)
    theo_equal=ybar*cbar**(-sigma)/(2*(1-beta))*(1/3*theo_Yvart+1/3*theo_Pvart+1/3*theo_ineqvart/(alpha*(1-alpha)))
#    theo_ineqvar+= [theo_ineqvart/(alpha*(1-alpha))]
#    theo_Yvar+=[theo_Yvart]
#    theo_Pvar+=[theo_Pvart]
#    theo_bvar+=[alpha/(1-alpha)*(variances[5,5]+variances[3,3]-2*variances[3,5])]
#
    

    if lossmeasure=='equal':
        returnloss=theo_equal
    elif lossmeasure=='welfare':
        returnloss=theo_welfare
    else:
        print(lossmeasure, 'is not a valid loss measure')
        returnloss='NaN'
    
    return returnloss






N2=101

phi_y_val=np.linspace(0,0.5,N2)

optphi1_a2=[]
optloss_a2=[]

for phi_y in phi_y_val:
    out=fmin(loss,2.5,full_output=1)    
    optphi1_a2+=[out[0][0]]
    optloss_a2+=[out[1]]
 

for j in range(len(phi_y_val)):
    print(phi_y_val[j],optphi1_a2[j])

for j in range(len(phi_y_val)):
    print(phi_y_val[j],optloss_a2[j])


plt.figure(18)  
plt.subplot(2, 1, 1)
plot(phi_y_val,optphi1_a2,linewidth=2)
plt.title('Optimal phi_pi')


plt.subplot(2, 1, 2)
plot(phi_y_val,optloss_a2,linewidth=2)
plt.title('Loss')   



