function g1 = dynamic_g1(T, y, x, params, steady_state, it_, T_flag)
% function g1 = dynamic_g1(T, y, x, params, steady_state, it_, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double   vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double   vector of endogenous variables in the order stored
%                                                     in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double   matrix of exogenous variables (in declaration order)
%                                                     for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double   vector of steady state values
%   params        [M_.param_nbr by 1]        double   vector of parameter values in declaration order
%   it_           scalar                     double   time period for exogenous variables for which
%                                                     to evaluate the model
%   T_flag        boolean                    boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   g1
%

if T_flag
    T = Mod_borrconst_binding_sym_iterparam.dynamic_g1_tt(T, y, x, params, steady_state, it_);
end
g1 = zeros(64, 100);
g1(1,27)=1;
g1(1,2)=(-(y(3)/y(41)));
g1(1,28)=1;
g1(1,3)=(-(y(2)/y(41)));
g1(1,30)=(-y(31));
g1(1,31)=(-y(30));
g1(1,33)=y(39)-y(7);
g1(1,37)=(-(1-y(38)));
g1(1,38)=y(37);
g1(1,7)=(-y(33));
g1(1,39)=y(33);
g1(1,41)=(-((-(y(3)*y(2)))/(y(41)*y(41))));
g1(2,29)=(-(T(2)*params(4)*T(22)));
g1(2,92)=(-(T(2)*params(4)*T(24)));
g1(2,57)=T(25);
g1(2,95)=(-(params(4)*y(29)/y(92)*(-(1-params(15)))/(y(95)*y(95))));
g1(3,30)=T(1);
g1(3,31)=(-(params(2)*getPowerDeriv(y(31),params(1),1)));
g1(3,57)=y(30)*T(25);
g1(4,33)=T(1);
g1(4,91)=(-(params(4)*T(2)));
g1(4,39)=(-(y(45)*getPowerDeriv(y(39),(-1),1)));
g1(4,45)=(-T(3));
g1(4,57)=y(33)*T(25);
g1(4,95)=(-(params(4)*y(91)*(-(1-params(15)))/(y(95)*y(95))));
g1(5,1)=params(15);
g1(5,27)=(-1);
g1(5,57)=1;
g1(6,2)=y(3)/y(41);
g1(6,28)=(-1);
g1(6,3)=y(2)/y(41);
g1(6,32)=1;
g1(6,33)=y(40)-y(8);
g1(6,34)=(-y(35));
g1(6,35)=(-y(34));
g1(6,8)=(-y(33));
g1(6,40)=y(33);
g1(6,41)=(-(y(3)*y(2)))/(y(41)*y(41));
g1(7,29)=(-(y(36)+T(5)*params(5)*T(22)));
g1(7,36)=(-y(29));
g1(7,92)=(-(T(5)*params(5)*T(24)));
g1(7,58)=T(26);
g1(7,96)=(-(y(29)/y(92)*params(5)*(-(1-params(15)))/(y(96)*y(96))));
g1(8,34)=T(4);
g1(8,35)=(-(params(2)*getPowerDeriv(y(35),params(1),1)));
g1(8,58)=y(34)*T(26);
g1(9,33)=T(4);
g1(9,91)=(-(params(5)*T(5)));
g1(9,36)=(-(y(46)*y(81)*y(82)));
g1(9,40)=(-((-y(45))/(y(40)*y(40))));
g1(9,45)=(-(1/y(40)));
g1(9,46)=(-(y(36)*y(81)*y(82)));
g1(9,58)=y(33)*T(26);
g1(9,96)=(-(y(91)*params(5)*(-(1-params(15)))/(y(96)*y(96))));
g1(9,81)=(-(y(36)*y(46)*y(82)));
g1(9,82)=(-(y(36)*y(46)*y(81)));
g1(10,4)=params(15);
g1(10,32)=(-1);
g1(10,58)=1;
g1(11,30)=1;
g1(11,31)=(-(y(38)*params(8)*(-y(37))/(y(31)*y(31))));
g1(11,37)=(-(y(38)*params(8)*1/y(31)));
g1(11,38)=(-(params(8)*y(37)/y(31)));
g1(12,34)=1;
g1(12,35)=(-(y(38)*(1-params(8))*(-y(37))/(y(35)*y(35))));
g1(12,37)=(-(y(38)*(1-params(8))*1/y(35)));
g1(12,38)=(-((1-params(8))*y(37)/y(35)));
g1(13,30)=(-(T(7)*1/params(8)*getPowerDeriv(y(30)/params(8),params(8),1)));
g1(13,34)=(-(T(6)*1/(1-params(8))*getPowerDeriv(y(34)/(1-params(8)),1-params(8),1)));
g1(13,38)=1;
g1(14,31)=(-(T(9)*getPowerDeriv(y(31),params(8),1)));
g1(14,35)=(-(T(8)*getPowerDeriv(y(35),1-params(8),1)));
g1(14,48)=1;
g1(15,42)=1;
g1(15,43)=(-((params(6)-1)/params(6)*y(47)));
g1(15,47)=(-((params(6)-1)/params(6)*y(43)));
g1(16,37)=(-(y(38)/y(57)));
g1(16,38)=(-(y(37)/y(57)));
g1(16,92)=(-(y(93)*params(4)*params(9)*getPowerDeriv(y(92),params(6),1)));
g1(16,42)=1;
g1(16,93)=(-T(10));
g1(16,57)=(-((-(y(38)*y(37)))/(y(57)*y(57))));
g1(17,37)=(-(1/y(57)));
g1(17,92)=(-(y(94)*params(4)*params(9)*getPowerDeriv(y(92),params(6)-1,1)));
g1(17,43)=1;
g1(17,94)=(-T(11));
g1(17,57)=(-((-y(37))/(y(57)*y(57))));
g1(18,41)=(-((-((1-params(9))*(-(params(9)*getPowerDeriv(y(41),params(6)-1,1)))))/(T(12)*T(12))*getPowerDeriv((1-params(9))/T(12),1/(params(6)-1),1)));
g1(18,47)=1;
g1(19,41)=(-(y(10)*params(9)*getPowerDeriv(y(41),params(6),1)));
g1(19,10)=(-T(13));
g1(19,44)=1;
g1(19,47)=(-((1-params(9))*getPowerDeriv(y(47),(-params(6)),1)));
g1(20,39)=1;
g1(20,40)=1;
g1(21,3)=(-(T(17)*getPowerDeriv(y(3),params(17),1)));
g1(21,29)=1;
g1(21,37)=(-(T(18)*T(14)*1/(steady_state(11))*getPowerDeriv(y(37)/(steady_state(11)),params(11),1)*T(23)));
g1(21,41)=(-(T(18)*T(23)*T(15)*1/params(4)*getPowerDeriv(y(41),params(10),1)));
g1(22,11)=(-(params(16)*1/y(11)));
g1(22,45)=1/y(45);
g1(22,69)=(-1);
g1(22,78)=(-1);
g1(22,97)=(-1);
g1(23,65)=1;
g1(23,98)=(-1);
g1(24,13)=(-1);
g1(24,66)=1;
g1(25,14)=(-1);
g1(25,67)=1;
g1(26,15)=(-1);
g1(26,68)=1;
g1(27,16)=(-1);
g1(27,69)=1;
g1(28,74)=(-1);
g1(28,78)=1;
g1(28,100)=(-1);
g1(29,70)=1;
g1(29,99)=(-1);
g1(30,17)=(-1);
g1(30,71)=1;
g1(31,18)=(-1);
g1(31,72)=1;
g1(32,19)=(-1);
g1(32,73)=1;
g1(33,20)=(-1);
g1(33,74)=1;
g1(34,27)=(-(1/y(37)));
g1(34,37)=(-((-y(27))/(y(37)*y(37))));
g1(34,49)=1;
g1(35,32)=(-(1/y(37)));
g1(35,37)=(-((-y(32))/(y(37)*y(37))));
g1(35,50)=1;
g1(36,33)=(-(1/(y(37)*4)));
g1(36,37)=(-((-(y(33)*4))/(y(37)*4*y(37)*4)));
g1(36,51)=1;
g1(37,33)=(-(y(39)/(y(37)*4)));
g1(37,37)=(-((-(4*y(33)*y(39)))/(y(37)*4*y(37)*4)));
g1(37,39)=(-(y(33)/(y(37)*4)));
g1(37,52)=1;
g1(38,33)=(-(y(40)/(y(37)*4)));
g1(38,37)=(-((-(4*y(33)*y(40)))/(y(37)*4*y(37)*4)));
g1(38,40)=(-(y(33)/(y(37)*4)));
g1(38,53)=1;
g1(39,28)=(-(1/(y(37)*4)));
g1(39,37)=(-((-(y(28)*4))/(y(37)*4*y(37)*4)));
g1(39,54)=1;
g1(40,28)=(-(1/(y(34)*y(35)*4)));
g1(40,34)=(-((-(y(28)*y(35)*4))/(y(34)*y(35)*4*y(34)*y(35)*4)));
g1(40,35)=(-((-(y(28)*y(34)*4))/(y(34)*y(35)*4*y(34)*y(35)*4)));
g1(40,64)=1;
g1(41,29)=(-400);
g1(41,60)=1;
g1(42,29)=(-100);
g1(42,59)=1;
g1(43,29)=(-(100*T(22)));
g1(43,92)=(-(100*T(24)));
g1(43,61)=1;
g1(44,29)=(-(400*T(22)));
g1(44,92)=(-(400*T(24)));
g1(44,62)=1;
g1(45,5)=(-((-y(33))/(y(5)*y(5))));
g1(45,33)=(-(1/y(5)));
g1(45,56)=1;
g1(46,2)=(-(4*(-y(28))/(y(2)*y(2))));
g1(46,28)=(-(4*1/y(2)));
g1(46,55)=1;
g1(47,41)=(-(y(77)*y(75)*y(76)));
g1(47,63)=1;
g1(47,75)=(-(y(77)*y(41)*y(76)));
g1(47,76)=(-(y(41)*y(75)*y(77)));
g1(47,77)=(-(y(41)*y(75)*y(76)));
g1(48,9)=(-1);
g1(48,75)=1;
g1(49,21)=(-1);
g1(49,76)=1;
g1(50,22)=(-1);
g1(50,77)=1;
g1(51,6)=(-((-y(37))/(y(6)*y(6))));
g1(51,37)=(-(1/y(6)));
g1(51,86)=1;
g1(52,24)=(-1);
g1(52,87)=1;
g1(53,25)=(-1);
g1(53,88)=1;
g1(54,26)=(-1);
g1(54,89)=1;
g1(55,86)=(-(y(89)*y(87)*y(88)));
g1(55,87)=(-(y(89)*y(86)*y(88)));
g1(55,88)=(-(y(89)*y(86)*y(87)));
g1(55,89)=(-(y(88)*y(86)*y(87)));
g1(55,90)=1;
g1(56,34)=(-y(35));
g1(56,35)=(-y(34));
g1(56,79)=1;
g1(57,30)=(-y(31));
g1(57,31)=(-y(30));
g1(57,80)=1;
g1(58,91)=(-1);
g1(58,81)=1;
g1(59,92)=(-1);
g1(59,82)=1;
g1(60,41)=(-((-(params(19)*y(23)))/(y(41)*y(41))));
g1(60,46)=(-((1-params(19))*y(83)));
g1(60,83)=(-(y(46)*(1-params(19))));
g1(60,23)=(-(params(19)/y(41)));
g1(60,84)=1;
g1(61,29)=(-(y(40)*(-(y(81)*y(82)))/(y(29)*y(29))));
g1(61,40)=(-(y(81)*y(82)/y(29)));
g1(61,81)=(-(y(40)*y(82)/y(29)));
g1(61,82)=(-(y(40)*y(81)/y(29)));
g1(61,83)=1;
g1(62,28)=1;
g1(62,84)=(-1);
g1(63,28)=(-1);
g1(63,84)=1;
g1(63,85)=1;
g1(64,12)=(-(T(20)*getPowerDeriv(y(12),params(18),1)));
g1(64,46)=1;
g1(64,54)=(-(T(21)*T(19)*1/(steady_state(28))*getPowerDeriv(y(54)/(steady_state(28)),(1-params(18))*(-params(12)),1)));

end
