function T = dynamic_g1_tt(T, y, x, params, steady_state, it_)
% function T = dynamic_g1_tt(T, y, x, params, steady_state, it_)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double  vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double  vector of endogenous variables in the order stored
%                                                    in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double  matrix of exogenous variables (in declaration order)
%                                                    for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double  vector of steady state values
%   params        [M_.param_nbr by 1]        double  vector of parameter values in declaration order
%   it_           scalar                     double  time period for exogenous variables for which
%                                                    to evaluate the model
%
% Output:
%   T           [#temp variables by 1]       double  vector of temporary terms
%

assert(length(T) >= 26);

T = Mod_borrconst_binding_sym_iterparam.dynamic_resid_tt(T, y, x, params, steady_state, it_);

T(22) = 1/y(92);
T(23) = getPowerDeriv(T(16),1-params(17),1);
T(24) = (-y(29))/(y(92)*y(92));
T(25) = (-(1-params(15)))/(y(57)*y(57));
T(26) = (-(1-params(15)))/(y(58)*y(58));

end
