function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
% function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double   vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double   vector of endogenous variables in the order stored
%                                                     in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double   matrix of exogenous variables (in declaration order)
%                                                     for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double   vector of steady state values
%   params        [M_.param_nbr by 1]        double   vector of parameter values in declaration order
%   it_           scalar                     double   time period for exogenous variables for which
%                                                     to evaluate the model
%   T_flag        boolean                    boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   residual
%

if T_flag
    T = Mod_borrconst_binding_sym_iterparam.dynamic_resid_tt(T, y, x, params, steady_state, it_);
end
residual = zeros(64, 1);
lhs = y(27)+y(28)+y(33)*(y(39)-y(7));
rhs = y(3)*y(2)/y(41)+y(30)*y(31)+(1-y(38))*y(37);
residual(1) = lhs - rhs;
lhs = T(1);
rhs = params(4)*y(29)/y(92)*T(2);
residual(2) = lhs - rhs;
lhs = y(30)*T(1);
rhs = params(2)*y(31)^params(1);
residual(3) = lhs - rhs;
lhs = y(33)*T(1);
rhs = y(45)*T(3)+params(4)*T(2)*y(91);
residual(4) = lhs - rhs;
lhs = y(57);
rhs = y(27)-params(15)*y(1);
residual(5) = lhs - rhs;
lhs = y(3)*y(2)/y(41)+y(32)+y(33)*(y(40)-y(8));
rhs = y(28)+y(34)*y(35);
residual(6) = lhs - rhs;
lhs = T(4);
rhs = y(29)/y(92)*params(5)*T(5)+y(29)*y(36);
residual(7) = lhs - rhs;
lhs = y(34)*T(4);
rhs = params(2)*y(35)^params(1);
residual(8) = lhs - rhs;
lhs = y(33)*T(4);
rhs = y(45)/y(40)+T(5)*y(91)*params(5)+y(36)*y(46)*y(81)*y(82);
residual(9) = lhs - rhs;
lhs = y(58);
rhs = y(32)-params(15)*y(4);
residual(10) = lhs - rhs;
lhs = y(30);
rhs = y(38)*params(8)*y(37)/y(31);
residual(11) = lhs - rhs;
lhs = y(34);
rhs = y(38)*(1-params(8))*y(37)/y(35);
residual(12) = lhs - rhs;
lhs = y(38);
rhs = T(6)*T(7);
residual(13) = lhs - rhs;
lhs = y(48);
rhs = T(8)*T(9);
residual(14) = lhs - rhs;
lhs = y(42);
rhs = (params(6)-1)/params(6)*y(47)*y(43);
residual(15) = lhs - rhs;
lhs = y(42);
rhs = y(38)*y(37)/y(57)+T(10)*y(93);
residual(16) = lhs - rhs;
lhs = y(43);
rhs = y(37)/y(57)+T(11)*y(94);
residual(17) = lhs - rhs;
lhs = y(47);
rhs = ((1-params(9))/T(12))^(1/(params(6)-1));
residual(18) = lhs - rhs;
lhs = y(44);
rhs = (1-params(9))*y(47)^(-params(6))+T(13)*y(10);
residual(19) = lhs - rhs;
lhs = y(39)+y(40);
rhs = 1;
residual(20) = lhs - rhs;
lhs = y(29);
rhs = T(17)*T(18);
residual(21) = lhs - rhs;
lhs = log(y(45));
rhs = (1-params(16))*log(params(3))+params(16)*log(y(11))+x(it_, 1)+y(78)+y(69);
residual(22) = lhs - rhs;
lhs = y(65);
rhs = x(it_, 2);
residual(23) = lhs - rhs;
lhs = y(66);
rhs = y(13);
residual(24) = lhs - rhs;
lhs = y(67);
rhs = y(14);
residual(25) = lhs - rhs;
lhs = y(68);
rhs = y(15);
residual(26) = lhs - rhs;
lhs = y(69);
rhs = y(16);
residual(27) = lhs - rhs;
lhs = y(78);
rhs = x(it_, 4)+y(74);
residual(28) = lhs - rhs;
lhs = y(70);
rhs = x(it_, 3);
residual(29) = lhs - rhs;
lhs = y(71);
rhs = y(17);
residual(30) = lhs - rhs;
lhs = y(72);
rhs = y(18);
residual(31) = lhs - rhs;
lhs = y(73);
rhs = y(19);
residual(32) = lhs - rhs;
lhs = y(74);
rhs = y(20);
residual(33) = lhs - rhs;
lhs = y(49);
rhs = y(27)/y(37);
residual(34) = lhs - rhs;
lhs = y(50);
rhs = y(32)/y(37);
residual(35) = lhs - rhs;
lhs = y(51);
rhs = y(33)/(y(37)*4);
residual(36) = lhs - rhs;
lhs = y(52);
rhs = y(33)*y(39)/(y(37)*4);
residual(37) = lhs - rhs;
lhs = y(53);
rhs = y(33)*y(40)/(y(37)*4);
residual(38) = lhs - rhs;
lhs = y(54);
rhs = y(28)/(y(37)*4);
residual(39) = lhs - rhs;
lhs = y(64);
rhs = y(28)/(y(34)*y(35)*4);
residual(40) = lhs - rhs;
lhs = y(60);
rhs = (y(29)-1)*400;
residual(41) = lhs - rhs;
lhs = y(59);
rhs = (y(29)-1)*100;
residual(42) = lhs - rhs;
lhs = y(61);
rhs = 100*(y(29)/y(92)-1);
residual(43) = lhs - rhs;
lhs = y(62);
rhs = 400*(y(29)/y(92)-1);
residual(44) = lhs - rhs;
lhs = y(56);
rhs = y(33)/y(5);
residual(45) = lhs - rhs;
lhs = y(55);
rhs = 4*y(28)/y(2);
residual(46) = lhs - rhs;
lhs = y(63);
rhs = y(41)*y(75)*y(76)*y(77);
residual(47) = lhs - rhs;
lhs = y(75);
rhs = y(9);
residual(48) = lhs - rhs;
lhs = y(76);
rhs = y(21);
residual(49) = lhs - rhs;
lhs = y(77);
rhs = y(22);
residual(50) = lhs - rhs;
lhs = y(86);
rhs = y(37)/y(6);
residual(51) = lhs - rhs;
lhs = y(87);
rhs = y(24);
residual(52) = lhs - rhs;
lhs = y(88);
rhs = y(25);
residual(53) = lhs - rhs;
lhs = y(89);
rhs = y(26);
residual(54) = lhs - rhs;
lhs = y(90);
rhs = y(89)*y(88)*y(86)*y(87);
residual(55) = lhs - rhs;
lhs = y(79);
rhs = y(34)*y(35);
residual(56) = lhs - rhs;
lhs = y(80);
rhs = y(30)*y(31);
residual(57) = lhs - rhs;
lhs = y(81);
rhs = y(91);
residual(58) = lhs - rhs;
lhs = y(82);
rhs = y(92);
residual(59) = lhs - rhs;
lhs = y(84);
rhs = (1-params(19))*y(46)*y(83)+params(19)*y(23)/y(41);
residual(60) = lhs - rhs;
lhs = y(83);
rhs = y(40)*y(81)*y(82)/y(29);
residual(61) = lhs - rhs;
lhs = y(28);
rhs = y(84);
residual(62) = lhs - rhs;
lhs = y(85);
rhs = y(28)-y(84);
residual(63) = lhs - rhs;
lhs = y(46);
rhs = T(20)*T(21);
residual(64) = lhs - rhs;

end
