%% HOUSING BOOM-BUST CYCLES AND ASYMMETRIC MACROPRUDENTIAL POLICY

% Calibration  
  
    betas       = 0.99009;
    betab       = 0.985;    % Calibration for the analysis of the OBC    
    varphi      = 0.5;      % Inv of Frisch elas. on labour supply (average Frisch = 1-3)     
    tau         = 0.844;    % Preference parameter on labour
    j_ss        = 0.06;     % Preference parameter on housing (q is 4 times borrower's annual salary)
    g           = 0.5;      % Habits in persistence
    m_ss        = 0.9;      % SS LTV ratio
    sigma       = 6;        % Elasticity of substitution (20% markup) 
    alphaa      = 0.64;     % Production parameter 
    omega       = 0.75;     % Fraction of non-adjusters in t
    gamma       = 0.0;      % Persistence in borrowing (not used)
    
%-----POLICY PARAMETERS-----------

    % Macroprudential policy
    % Policy parameter - LTV ratio
%     delta_m     = 0.0;        % USED TO GENERATE IRFS FOR PASSIVE POLICY
    delta_m     = 0.75;         % benchmark
    delta_mL    = delta_m;      
%      delta_mH    = 2*delta_m; %  USED FOR ILLUSTRATIVE IRFs ONLY
    delta_mH    = 32.5;         % OPTIMISED PARAMETER
    rho_m       = 0.0;          % Smoothness in phi (LTV)
    
    % Monetary Policy
    delta_Pi    = 1.5;      % Policy parameter - inflation
    delta_Y     = 0.125;    % Policy parameter - output
    rho_R       = 0.8;      % Smoothness in R
    
    % Shock processes 
    rho_j       = 0.96;      % Persistence parameter for v_t 


